/*
 * DodgeDefender.java Max Biel
 *
 * CapStone Project
 *
 * Copyright (c) 2013 Max Biel. All Rights Reserved.
 *
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Applet for DodgeDefender, sets everything up and uses the panel.
 *
 * @version 1.10 08 Apr 2013
 * @author Max Biel
 *
 * history: !!!
 *      xxx 08apr2013: Started Class
 */
public class DodgeDefender extends JApplet
{
    private final int WIDTH = 800, HEIGHT = 800;
    
    /**
     * Sets initial contentPane (intro screen) and sets ideal height and width of game.
     */
    public void init()
    {
        setSize(WIDTH, HEIGHT);

        getContentPane().add(new IntroScreen());
    }
    
    /**
     * Switches content pane to the main game, which starts the actual game.
     */
    public void mainGame()
    {
        getContentPane().invalidate();
        
        getContentPane().removeAll();
        
        
        getContentPane().add(new MainGame());
        
        getContentPane().validate();
        
        repaint();

        
    }
    
    /**
     * Switches content pane to the intro screen, if a user is restarting.
     */
    public void introScreen()
    {
        getContentPane().invalidate();
        getContentPane().removeAll();
        getContentPane().add(new IntroScreen());
        getContentPane().validate();
        repaint();
    }
    

}
