/*
 * Enemy.java Max Biel
 *
 * CapStone Project
 *
 * Copyright (c) 2013 Max Biel. All Rights Reserved.
 *
 */

import java.util.Random;

/**
 * Serves as the enemy in Dodge Defender. The hero will not touch the enemy who go at various speeds
 * and start at various places.
 *
 * @version 1.10 09 Apr 2013
 * @author Max Biel
 *
 * history: !!!
 *      xxx 09apr2013: Started Class
 */
public class Enemy 
{
    private int radius;
    private int x;
    private int y;
    private int speedX;
    private int speedY;
    private Random generator = new Random();
    
    /**
     * First constructor allowing most parameters to be set.
     */
    public Enemy(int positionY, int velocX, int velocY)
    {
        y = positionY;
        speedX = velocX;
        speedY = velocY;
        x = 800;
    }
    
    /**
     * Second constructor allowing only radius to be set.
     */
    public Enemy(int r)
    {
        radius = r;
        int posY = generator.nextInt(800);
        speedX = generator.nextInt(10);
        speedY = generator.nextInt(5) - 5;
        y = posY;
        x = 799;
    }
    
    /**
     * Third constructor setting everything to default.
     */
    public Enemy()
    {
        radius = 6;
        int posY = generator.nextInt(800);
        speedX = generator.nextInt(15);
        speedY = generator.nextInt(5);
        y = posY;
        x = 799;
    }
    
    /**
     * Sets radius.
     */
    public void setRadius(int r)
    {
        radius = r;
    }
    
    /**
     * Returns radius.
     */
    public int getRadius()
    {
        return radius;
    }
    
    /**
     * Sets x cooridinate.
     */
    public void setX(int posX)
    {
        x = posX;
    }
    
    /**
     * Returns x cooridinate.
     */
    public int getX()
    {
        return x;
    }
    
    /**
     * Sets y cooridinate.
     */
    public void setY(int posY)
    {
        y = posY;
    }
    
    /**
     * Returns y cooridinate.
     */
    public int getY()
    {
        return y;
    }
    
    /**
     * Sets horizontal speed.
     */
    public void setSpeedX(int velocX)
    {
        speedX = velocX;
    }
    
    /**
     * Returns horizontal speed.
     */
    public int getSpeedX()
    {
        return speedX;
    }
    
    /**
     * Sets vertical speed.
     */
    public void setSpeedY(int velocY)
    {
        speedY = velocY;
    }
    
    /**
     * Returns vertical speed.
     */
    public int getSpeedY()
    {
        return speedY;
    }
    
    /**
     * Changes x and y based on their vertical and horizontal speed, effectively moving them.
     */
    public void move()
    {
        x -= speedX;
        y -= speedY;
    }
    
    /**
     * Keeps all enemys on the screen so they wrap around the plain.
     */
    public void wrap()
    {
        if (x <= 0)
        {
            x = 799;
        }
        
        else if (x >= 800)
        {
            x = 1;
        }
        
        else if (y <= 0)
        {
            y = 799;
        }
        
        else if (y >= 800)
        {
            y = 1;
        }
    }
}