/*
 * Hero.java Max Biel
 *
 * CapStone Project
 *
 * Copyright (c) 2013 Max Biel. All Rights Reserved.
 *
 */


/**
 * Protagonist or hero in the Dodge Defender Game. Make it to the other side and you get to the next
 * level.
 *
 * @version 1.10 10 Apr 2013
 * @author Max Biel
 *
 * history: !!!
 *      xxx 10apr2013: Started Class
 */


public class Hero 
{
    private int x;
    private int y;
    public  int speedX = 0;
    public  int speedY = 0;
    private boolean alive = true;
    
    
    /**
     * Constructor for Hero object, sets instance variables
     */
    public Hero()
    {
        x = 0;
        y = 400; 
    }
    
    /**
     * Sets x cooridinate
     */
    public void setX (int posX)
    {
        x = posX;
    }
    
    
    /**
     * Returns x cooridinate
     */
    public int getX()
    {
        return x;
    }
    
    
    /**
     * Sets y cooridinate
     */
    public void setY(int posY)
    {
        y = posY;
    }
    
    /**
     * Returns y cooridinate
     */
    public int getY()
    {
        return y;
    }
    
    /**
     * Adds speeds to x and y cooridinate, advancing their pixel position
     */
    public void move()
    {
        x += speedX;
        y += speedY;
    }
    
    
    /**
     * Returns vertical speed.
     */
    public int getSpeedY()
    {
        return speedY;
    }
    
    /**
     * Sets vertical speed.
     */
    public void setSpeedY(int ySpeed)
    {
        speedY = ySpeed;
    }
    
    /**
     * Returns horizontal speed.
     */
    public int getSpeedX()
    {
        return speedX;
    }
    
    /**
     * Sets horizontal speed.
     */
    public void setSpeedX(int xSpeed)
    {
        speedX = xSpeed;
    }
    
    /**
     * Returns condition of boolean flag alive.
     */
    public boolean getAlive()
    {
        return alive;
    }
    
    /**
     * Sets boolean flag condition to false.
     */
    public void die()
    {
        alive = false;
    }
    
    /**
     * Makes hero wrap around screen. The hero never leaves the screen.
     */
    public void wrap()
    {
        if (x < 0)
        {
            x = 0;
        }
        
        else if (y < 0)
        {
            y = 800;
        }
        
        else if (y > 800)
        {
            y = 0;
        }
    }
}